JUCE: ChannelRemappingAudioSource Class Reference

JUCE

- Main Page
- Related Pages
- Topics
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Loading...
Searching...
No Matches
Public Member Functions | List of all members
ChannelRemappingAudioSource Class Reference
juce_audio_basics » sources

An AudioSource that takes the audio from another source, and re-maps its input and output channels to a different arrangement. More...

`#include <juce_ChannelRemappingAudioSource.h>`

Inheritance diagram for ChannelRemappingAudioSource:

## Public Member Functions
| ChannelRemappingAudioSource (AudioSource *source, bool deleteSourceWhenDeleted)
| Creates a remapping source that will pass on audio from the given input.
| ~ChannelRemappingAudioSource () override
| Destructor.
void | setNumberOfChannelsToProduce (int requiredNumberOfChannels)
| Specifies a number of channels that this audio source must produce from its getNextAudioBlock() callback.
void | clearAllMappings ()
| Clears any mapped channels.
void | setInputChannelMapping (int destChannelIndex, int sourceChannelIndex)
| Creates an input channel mapping.
void | setOutputChannelMapping (int sourceChannelIndex, int destChannelIndex)
| Creates an output channel mapping.
int | getRemappedInputChannel (int inputChannelIndex) const
| Returns the channel from our input that will be sent to channel inputChannelIndex of our input audio source.
int | getRemappedOutputChannel (int outputChannelIndex) const
| Returns the output channel to which channel outputChannelIndex of our input audio source will be sent to.
std::unique_ptr< XmlElement > | createXml () const
| Returns an XML object to encapsulate the state of the mappings.
void | restoreFromXml (const XmlElement &)
| Restores the mappings from an XML object created by createXML().
void | prepareToPlay (int samplesPerBlockExpected, double sampleRate) override
| Tells the source to prepare for playing.
void | releaseResources () override
| Allows the source to release anything it no longer needs after playback has stopped.
void | getNextAudioBlock (const AudioSourceChannelInfo &) override
| Called repeatedly to fetch subsequent blocks of audio data.
Public Member Functions inherited from AudioSource
virtual | ~AudioSource ()=default
| Destructor.

## Additional Inherited Members
Protected Member Functions inherited from AudioSource
| AudioSource ()=default
| Creates an AudioSource.

## Detailed Description

An AudioSource that takes the audio from another source, and re-maps its input and output channels to a different arrangement.

You can use this to increase or decrease the number of channels that an audio source uses, or to re-order those channels.

Call the reset() method before using it to set up a default mapping, and then the setInputChannelMapping() and setOutputChannelMapping() methods to create an appropriate mapping, otherwise no channels will be connected and it'll produce silence.

See also
  AudioSource

## Constructor & Destructor Documentation

## ◆ ChannelRemappingAudioSource()

ChannelRemappingAudioSource::ChannelRemappingAudioSource | ( | AudioSource * | source,
|  | bool | deleteSourceWhenDeleted )

Creates a remapping source that will pass on audio from the given input.

Parameters

  source | the input source to use. Make sure that this doesn't get deleted before the ChannelRemappingAudioSource object
  deleteSourceWhenDeleted | if true, the input source will be deleted when this object is deleted, if false, the caller is responsible for its deletion

## ◆ ~ChannelRemappingAudioSource()

ChannelRemappingAudioSource::~ChannelRemappingAudioSource | ( |  | ) |
| override

Destructor.

## Member Function Documentation

## ◆ setNumberOfChannelsToProduce()

void ChannelRemappingAudioSource::setNumberOfChannelsToProduce | ( | int | requiredNumberOfChannels | ) |

Specifies a number of channels that this audio source must produce from its getNextAudioBlock() callback.

## ◆ clearAllMappings()

void ChannelRemappingAudioSource::clearAllMappings | ( |  | ) |

Clears any mapped channels.

After this, no channels are mapped, so this object will produce silence. Create some mappings with setInputChannelMapping() and setOutputChannelMapping().

## ◆ setInputChannelMapping()

void ChannelRemappingAudioSource::setInputChannelMapping | ( | int | destChannelIndex,
|  | int | sourceChannelIndex )

Creates an input channel mapping.

When the getNextAudioBlock() method is called, the data in channel sourceChannelIndex of the incoming data will be sent to destChannelIndex of our input source.

Parameters

  destChannelIndex | the index of an input channel in our input audio source (i.e. the source specified when this object was created).
  sourceChannelIndex | the index of the input channel in the incoming audio data buffer during our getNextAudioBlock() callback

## ◆ setOutputChannelMapping()

void ChannelRemappingAudioSource::setOutputChannelMapping | ( | int | sourceChannelIndex,
|  | int | destChannelIndex )

Creates an output channel mapping.

When the getNextAudioBlock() method is called, the data returned in channel sourceChannelIndex by our input audio source will be copied to channel destChannelIndex of the final buffer.

Parameters

  sourceChannelIndex | the index of an output channel coming from our input audio source (i.e. the source specified when this object was created).
  destChannelIndex | the index of the output channel in the incoming audio data buffer during our getNextAudioBlock() callback

## ◆ getRemappedInputChannel()

int ChannelRemappingAudioSource::getRemappedInputChannel | ( | int | inputChannelIndex | ) | const

Returns the channel from our input that will be sent to channel inputChannelIndex of our input audio source.

## ◆ getRemappedOutputChannel()

int ChannelRemappingAudioSource::getRemappedOutputChannel | ( | int | outputChannelIndex | ) | const

Returns the output channel to which channel outputChannelIndex of our input audio source will be sent to.

## ◆ createXml()

std::unique_ptr< XmlElement > ChannelRemappingAudioSource::createXml | ( |  | ) | const

Returns an XML object to encapsulate the state of the mappings.

See also
  restoreFromXml

## ◆ restoreFromXml()

void ChannelRemappingAudioSource::restoreFromXml | ( | const XmlElement & |  | ) |

Restores the mappings from an XML object created by createXML().

See also
  createXml

## ◆ prepareToPlay()

void ChannelRemappingAudioSource::prepareToPlay | ( | int | samplesPerBlockExpected,
|  | double | sampleRate )
| overridevirtual

Tells the source to prepare for playing.

An AudioSource has two states: prepared and unprepared.

The prepareToPlay() method is guaranteed to be called at least once on an 'unprepared' source to put it into a 'prepared' state before any calls will be made to getNextAudioBlock(). This callback allows the source to initialise any resources it might need when playing.

Once playback has finished, the releaseResources() method is called to put the stream back into an 'unprepared' state.

Note that this method could be called more than once in succession without a matching call to releaseResources(), so make sure your code is robust and can handle that kind of situation.

Parameters

  samplesPerBlockExpected | the number of samples that the source will be expected to supply each time its getNextAudioBlock() method is called. This number may vary slightly, because it will be dependent on audio hardware callbacks, and these aren't guaranteed to always use a constant block size, so the source should be able to cope with small variations.
  sampleRate | the sample rate that the output will be used at - this is needed by sources such as tone generators.

See also
  releaseResources, getNextAudioBlock

Implements AudioSource.

## ◆ releaseResources()

void ChannelRemappingAudioSource::releaseResources | ( |  | ) |
| overridevirtual

Allows the source to release anything it no longer needs after playback has stopped.

This will be called when the source is no longer going to have its getNextAudioBlock() method called, so it should release any spare memory, etc. that it might have allocated during the prepareToPlay() call.

Note that there's no guarantee that prepareToPlay() will actually have been called before releaseResources(), and it may be called more than once in succession, so make sure your code is robust and doesn't make any assumptions about when it will be called.

See also
  prepareToPlay, getNextAudioBlock

Implements AudioSource.

## ◆ getNextAudioBlock()

void ChannelRemappingAudioSource::getNextAudioBlock | ( | const AudioSourceChannelInfo & | bufferToFill | ) |
| overridevirtual

Called repeatedly to fetch subsequent blocks of audio data.

After calling the prepareToPlay() method, this callback will be made each time the audio playback hardware (or whatever other destination the audio data is going to) needs another block of data.

It will generally be called on a high-priority system thread, or possibly even an interrupt, so be careful not to do too much work here, as that will cause audio glitches!

See also
  AudioSourceChannelInfo, prepareToPlay, releaseResources

Implements AudioSource.

The documentation for this class was generated from the following file:

- juce_ChannelRemappingAudioSource.h